Name:           nx
Version:        1.5.0
Release:        10%{?dist}
Summary:        Proxy system for X11

Group:          Applications/Internet
License:        GPL, MIT/X11 for X11 bits
URL:            http://www.nomachine.com
Source0:	nxproxy-1.5.0-9.tar.gz
Source1:	nxcomp-1.5.0-80.tar.gz
Source2:	nxcompext-1.5.0-20.tar.gz
Source3:	nx-X11-1.5.0-21.tar.gz
Source4:	nxagent-1.5.0-112.tar.gz
Source5:	nxviewer-1.5.0-15.tar.gz
Source6:	nxdesktop-1.5.0-78.tar.gz
Source7:	nxscripts-1.5.0-11.tar.gz
Source9:	nxagent
Source10:	docs.tar.bz2
Source11:	nxfind-provides.sh
Patch0:		NX.diff
Patch1:		NX-noansi.diff
Patch2:		p_XFree86-4.3-ppc64.diff
Patch3:		RenderExtension.diff
Patch5:		NX-bufferoverflow.diff
Patch6:		NX-data-range.patch
Patch7:		ppc-no-signed-char.diff

%define _use_internal_dependency_generator 0
%define __find_provides %{SOURCE11}

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  expat-devel audiofile-devel openssl-devel libjpeg-devel libpng-devel XFree86-devel xorg-x11-deprecated-libs-devel
Requires:	xorg-x11 xorg-x11-tools
Requires(post): policycoreutils
Requires(postun): policycoreutils
Excludearch:	x86_64

%description
NX provides a proxy system for the X Window System.

%prep
%setup -q -T -c %{name}-%{version} -a0 -a1 -a2 -a3 -a4 -a5 -a6 -a7
%patch0 -p0
%patch3 -p0
pushd nx-X11
%patch1 -p0
%patch2 -p1
popd
%patch5 -p0
%patch6 -p1
%patch7 -p0
ln -s rdesktop.1 nxdesktop/doc/nxdesktop.1
cat >> nx-X11/config/cf/host.def << EOF
#ifdef  i386Architecture
#undef  DefaultGcc2i386Opt
#define DefaultGcc2i386Opt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef  MipsArchitecture
#undef  DefaultGcc2MipsOpt
#define DefaultGcc2MipsOpt      $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
#ifdef s390xArchitecture
#undef OptimizedCDebugFlags
#define OptimizedCDebugFlags $RPM_OPT_FLAGS -fno-strict-aliasing
#endif
EOF

%build
%ifarch x86_64
export CFLAGS="%{optflags} -fPIC"
export CXXFLAGS="%{optflags} -fPIC"
%else
export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"
%endif
perl -pi -e"s|CXXFLAGS=.-O.*|CXXFLAGS=\"$CXXFLAGS\"|" */configure
# build Compression Library and Proxy
for i in nxcomp nxproxy; do
  pushd $i; ./configure; make; popd
done
# build X11 Support Libraries and Agents
pushd nx-X11
  make World
popd
# build Extended Compression Library
pushd nxcompext
  ./configure; make
popd
# build RFB Agent
pushd nxviewer
  xmkmf -a
  cp -a /usr/X11R6/%{_lib}/libXp.so* ../nx-X11/exports/lib/
  make 2> /dev/null
popd
# build RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  ./configure --prefix=%{_prefix} --sharedir=%{_datadir}/NX
  make
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/NX/lib
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
# install X11 Support Libraries and Agents
cp -a nx-X11/lib/X11/libX11.so.* \
      nx-X11/lib/Xext/libXext.so.* \
      nx-X11/lib/Xrender/libXrender.so.* \
      $RPM_BUILD_ROOT/%{_libdir}/NX/lib
install -m 755 nx-X11/programs/Xserver/nxagent \
  $RPM_BUILD_ROOT/%{_libdir}/NX
install -m 755 %{SOURCE9} $RPM_BUILD_ROOT/%{_bindir}
# install Compression Libraries and Proxy
cp -a nxcomp/libXcomp.so.* $RPM_BUILD_ROOT/%{_libdir}/NX/lib
cp -a nxcompext/libXcompext.so.* $RPM_BUILD_ROOT/%{_libdir}/NX/lib
install -m 755 nxproxy/nxproxy $RPM_BUILD_ROOT/%{_libdir}/NX
ln -snf nxagent $RPM_BUILD_ROOT/%{_bindir}/nxproxy
# install RFB Agent
pushd nxviewer
  make install DESTDIR=$RPM_BUILD_ROOT
  mv $RPM_BUILD_ROOT/usr/X11R6/bin/nxviewer $RPM_BUILD_ROOT/%{_libdir}/NX
  ln -snf nxagent $RPM_BUILD_ROOT/%{_bindir}/nxviewer
  chmod 755 $RPM_BUILD_ROOT/%{_bindir}/nxviewer
  mv $RPM_BUILD_ROOT/usr/X11R6/bin/nxpasswd $RPM_BUILD_ROOT/%{_bindir}
popd
# install RDP Agent
%ifnarch ppc ppc64 s390 s390x
pushd nxdesktop
  make install DESTDIR=$RPM_BUILD_ROOT
  mv $RPM_BUILD_ROOT/%{_bindir}/nxdesktop $RPM_BUILD_ROOT/%{_libdir}/NX
  ln -snf nxagent $RPM_BUILD_ROOT/%{_bindir}/nxdesktop
  chmod 755 $RPM_BUILD_ROOT/%{_bindir}/nxdesktop
  mv $RPM_BUILD_ROOT/usr/man/man1/nxdesktop.1 \
     $RPM_BUILD_ROOT/%{_mandir}/man1/nxdesktop.1
  rm -rf $RPM_BUILD_ROOT/usr/man
popd
%endif
# install scripts
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
cp -r nxscripts $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
# documentation and license
tar xjf %{SOURCE10} -C $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
install -m 644 nxcomp/LICENSE   $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX
for i in nxcomp nxdesktop; do
  mkdir $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/$i
done
install -m 644 nxcomp/README    $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/nxcomp
install -m 644 nxdesktop/README $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/nxdesktop
rm -rf nxdesktop/doc/CVS
cp -r nxdesktop/doc $RPM_BUILD_ROOT/%{_datadir}/doc/packages/NX/nxdesktop

%post
%{_sbindir}/semanage fcontext -f -- -a -t textrel_shlib_t '%{_libdir}/NX/lib/libXcomp.so.1.5.0' 2>/dev/null || :
%{_sbindir}/semanage fcontext -f -- -a -t textrel_shlib_t '%{_libdir}/NX/lib/libXcompext.so.1.5.0' 2>/dev/null || :
%{_bindir}/chcon -t textrel_shlib_t %{_libdir}/NX/lib/libXcomp.so.1.5.0 2>/dev/null || :
%{_bindir}/chcon -t textrel_shlib_t %{_libdir}/NX/lib/libXcompext.so.1.5.0 2>/dev/null || :

%postun
if [ $1 -eq 0 ]; then
  %{_sbindir}/semanage fcontext -f -- -d -t textrel_shlib_t '%{_libdir}/NX/lib/libXcomp.so.1.5.0' 2>/dev/null || :
  %{_sbindir}/semanage fcontext -f -- -d -t textrel_shlib_t '%{_libdir}/NX/lib/libXcompext.so.1.5.0' 2>/dev/null || :
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc %{_datadir}/doc/packages/NX
%{_bindir}/*
%dir %{_libdir}/NX
%{_libdir}/NX/*
%ifnarch ppc ppc64 s390 s390x
%dir %{_datadir}/NX
%{_mandir}/man1/nxdesktop.1.gz
%{_datadir}/NX/keymaps-windows/
%endif

%changelog
* Sun Jun 11 2006 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-10
- upping package release to match FC5
- added Source11 to filter find-provides from showing libraries that should not
  be provided to the system.
- added Dist tag
- fixed macro/variable inconsistencies
- added requires: post and postun for policycoreutils
- adapting spec for fedora-extras
- excluding x86_64 arch at this time. nxagent causes segfaults
- added support for selinux
* Tue Dec 13 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-4
- updated perl script line 76 to have quotes
* Tue Dec 13 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-3
- updated all compents to most recent release - Maintenance 3
- removed NX-1.5.diff
* Wed Aug 31 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-2
- updated nxagent to ver .90
- added patches from SuSE to update some compiler warnings and buffer overflows
* Fri Aug 12 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-1
- updated nxcomp to ver .65
* Tue Jul 26 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.5.0-0
- Updated to 1.5.0 final
* Mon Jul 11 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.4.9.4-0
- Updated to 1.5.0 snapshot 4
* Thu Jun 30 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.4.9.3-0
- reworked package for update to 1.5.0 devel snapshot 3 (1.4.9.3)
- Commented out Xtranssock patch in NX.diff (doesn't seem to be necessary)
* Mon Apr 11 2005 Tom "spot" Callaway <tcallawa@redhat.com> - 1.4.0-5
- spec cleanups
- reworked Patch1 to make it apply without arch conditional
* Mon Feb 14 2005 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-4
- updated nx-X11, nxproxy, nxcomp, nxagent and nxdesktop
- released to address X11 security concerns.
* Tue Nov 09 2004 Rick Stout <zipsonci[AT]gmail.com> - 1.4.0-3
- updated to 1.4.0 final
* Mon Oct 11 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-2
- Changed naming structure to be more friendly (lowercase)
* Fri Oct 07 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-1
- Updated package dependencies
* Wed Sep 29 2004 Rick Stout <zipsonic[AT]gmail.com> - 1.4.0-0
- Initial Fedora RPM release.
- Updated SuSE package to work with Fedora
